package restx.admin;

import com.google.common.collect.ImmutableSet;
import restx.factory.*;
import restx.admin.AdminPagesResourceRouter;

@Machine
public class AdminPagesResourceRouterFactoryMachine extends SingleNameFactoryMachine<AdminPagesResourceRouter> {
    public static final Name<AdminPagesResourceRouter> NAME = Name.of(AdminPagesResourceRouter.class, "AdminPagesResourceRouter");

    public AdminPagesResourceRouterFactoryMachine() {
        super(0, new StdMachineEngine<AdminPagesResourceRouter>(NAME, BoundlessComponentBox.FACTORY) {
private final Factory.Query<restx.admin.AdminPagesResource> resource = Factory.Query.byClass(restx.admin.AdminPagesResource.class).mandatory();
private final Factory.Query<com.fasterxml.jackson.databind.ObjectMapper> mapper = Factory.Query.byClass(com.fasterxml.jackson.databind.ObjectMapper.class).mandatory();
private final Factory.Query<restx.converters.MainStringConverter> converter = Factory.Query.byClass(restx.converters.MainStringConverter.class).mandatory();
private final Factory.Query<javax.validation.Validator> validator = Factory.Query.byClass(javax.validation.Validator.class).mandatory();

            @Override
            public BillOfMaterials getBillOfMaterial() {
                return new BillOfMaterials(ImmutableSet.<Factory.Query<?>>of(
resource,
mapper,
converter,
validator
                ));
            }

            @Override
            protected AdminPagesResourceRouter doNewComponent(SatisfiedBOM satisfiedBOM) {
                return new AdminPagesResourceRouter(
satisfiedBOM.getOne(resource).get().getComponent(),
satisfiedBOM.getOne(mapper).get().getComponent(),
satisfiedBOM.getOne(converter).get().getComponent(),
satisfiedBOM.getOne(validator).get().getComponent()
                );
            }
        });
    }

}
